/*
 * FastTextSearch for InterBase 1.6 from 2 Jun 2003
 *
 * Copyright (c) 1998-2003 by SoftComplete Development
 * Web    http://www.softcomplete.com
 * Email  support@softcomplete.com
 *
 * This script update FTSCore from vers. 1.4/1.5 to 1.6
 */

/* CHANGE database name, username and password in next line */
connect "database.gdb" user "SYSDBA" password "masterkey";

SET TERM ^ ;

ALTER TABLE TS$QUERY
ADD WID INTEGER
^

CREATE TRIGGER T_BI_TS$QUERY FOR TS$QUERY
ACTIVE BEFORE INSERT POSITION 0
as
begin
  new.WID = Gen_ID(UID,1);
end
^

ALTER PROCEDURE TS$SELECT_AND1 (
    OBJ_TYPE VARCHAR(32),
    QID INTEGER,
    SOUNDEXFLAG INTEGER)
RETURNS (
    WORD_ID INTEGER,
    OBJ_ID INTEGER)
AS
DECLARE VARIABLE O_TYPE VARCHAR(32);
begin
  if (SoundExFlag = 1) then
    for 
      select distinct Q.WID, L.obj_id
        from TS$LINK L, TS$VOCAB V, TS$QUERY Q
        where V.SND_CODE = Q.SND_CODE
          and Q.ID = :qID
          and L.word_id = V.id
      into :WORD_ID,:OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
  else
    for 
      select distinct Q.WID, L.obj_id
        from TS$LINK L, TS$VOCAB V, TS$QUERY Q
        where V.WORD >= Q.WORD
          and V.WORD starting with Q.WORD
          and Q.ID = :qID
          and L.word_id = V.id
      into :WORD_ID,:OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
end
^

SET TERM ; ^

commit work;
